// File: GeoObj.cc

#include <GeoObj.h>
#include <AbstFcry.h>

int operator==(const GeoObj& left, const GeoObj& right)
{
  if(&left == &right)
    return 1;
  else
    return left.CompareTo(&right);
}

int operator!=(const GeoObj& left, const GeoObj& right)
{
  return !(left.CompareTo(&right));
}

ostream& operator<<(ostream& ros, const GeoObj& gos)
{
  gos.WriteOn(ros);
  return ros;
}

istream& operator>>(istream& ris, GeoObj& gis)
{
  if(ris)
    gis.ReadFrom(ris);
  return ris;
}
