// File: MultiVer.cc

#include <iostream.h>

class A {
  int x;
public:
  A(int _x): x(_x){}
  void print()
    { cout << x << "\n"; }
};

class B {
  char y;
public:
  B(char _y): y(_y){}
  void print()
    { cout << y << "\n"; }
};

class C: public A, public B {
  float z;
public:
  C(int _A, char _B, float _z)
  : A(_A), B(_B), z(_z){}
  void print()
    { A::print(); B::print(); printC(); }
  void printC()
    { cout << z << "\n"; }
};

int main()
{
  C c(1, 'A', 3.3);

  c.print();

  return 0;
}
