// File: KreisN.h

#ifndef Kreis_h
#define Kreis_h 1

#include <PROTECT/GeoObjN.h>
#include <PunktN.h>

class Kreis : public GeoObj  
{
private:
  static const float PI;
  Punkt MittelPunkt;
  float Radius;

protected:
  virtual int CompareTo(const GeoObj*) const;

public:
  Kreis(const Punkt& = Punkt(.0, .0), float = .0);
  Kreis(const Kreis &right);
    
  const Kreis & operator=(const Kreis &right);
    
  const Punkt get_MittelPunkt() const;
  void set_MittelPunkt(const Punkt value);

  const float get_Radius() const;
  void set_Radius(const float value);
      
  virtual float flaeche() const;
  virtual String GetTypeString() const;
};

inline const float Kreis::get_Radius() const
{
  return Radius;
}

inline void Kreis::set_Radius(const float value)
{
  Radius = value;
}

inline const Punkt Kreis::get_MittelPunkt() const
{
  return MittelPunkt;
}

inline void Kreis::set_MittelPunkt(const Punkt value)
{
  MittelPunkt = value;
}

#endif
