// File: SiOpCall.h

#include <iostream.h>

class S {
  int s;
protected:
  ostream& _printOn(ostream& ros)
  { return (ros << " " << s); }
public:
  S(int _s) : s(_s){}
  virtual ostream& printOn(ostream& ros)
  { return _printOn(ros); }
};

ostream& operator<<(ostream& ros, S& rs)
{
  return (rs.printOn(ros));
}

class A: virtual public S {
  int x;
protected:
  ostream& _printOn(ostream& ros)
  { return (ros << " " << x); }
public:
  A(int _x)
  : S(111), x(_x){}
  virtual ostream& printOn(ostream& ros)
  { S::_printOn(ros);
    return _printOn(ros); }
};

class B: virtual public S {
  char y;
protected:
  ostream& _printOn(ostream& ros)
  { return (ros << " " << y); }
public:
  B(char _y)
  : S(222), y(_y){}
  virtual ostream& printOn(ostream& ros)
  { S::_printOn(ros);
    return _printOn(ros); }
};

class C: public A, public B {
  float z;
protected:
  ostream& _printOn(ostream& ros)
  { return (ros << " " << z); }
public:
  C(int _A, char _B, float _z)
  : S(333), A(_A), B(_B), z(_z){}
  virtual ostream& printOn(ostream& ros)
  { S::_printOn(ros); A::_printOn(ros); B::_printOn(ros);
    return _printOn(ros);
  }
};
