// File: ZGeoObj.h

#ifndef ZGeoObj_h
#define ZGeoObj_h 1

#include <GeoObj.h>
#include <AbstFcry.h>

class ZGeoObj : public GeoObj  
{
private:
  enum{MAX = 100};
  int Count;
  GeoObj* GeoObjs[MAX];

protected:
  virtual int CompareTo(const GeoObj*) const;

public:
  ZGeoObj(AbstractFactory* = NULL);
  ZGeoObj(const ZGeoObj &right);
    
  const ZGeoObj& operator=(const ZGeoObj &right);
      
  void Add(GeoObj& _GeoObj);
  GeoObj* Remove(GeoObj& _GeoObj);
      
  GeoObj* GetGeoObj(int i);

  virtual GeoObj* Clone() const;
  virtual float flaeche() const;
  virtual String GetTypeString() const;
  virtual void WriteOn(ostream&) const;
  virtual void ReadFrom(istream&);
};

#endif
