// File: ArrInit.h

#include <iostream.h>

struct PublicS
{
  int i;
  char *s;
  float f;
};

class PublicC
{
public:
  int i;
  char *s;
  float f;
};

struct PrivateS
{
private:
  int i;
  char *s;
  float f;

friend ostream& printOn(ostream&, const PrivateS&, const char*);
friend ostream& printOn(ostream&, const PrivateS*, const char*, int);
};

class PrivateC
{
  int i;
  char *s;
  float f;

friend ostream& printOn(ostream&, const PrivateC&, const char*);
friend ostream& printOn(ostream&, const PrivateC*, const char*, int);
};

class NoDefaultC
{
public:
  int i;
  char *s;
  float f;

  NoDefaultC(int _i, char *_s, float _f)
  : i(_i), s(_s), f(_f){}
};

class DefaultC
{
public:
  int i;
  char *s;
  float f;

  DefaultC(int _i = 0, char *_s = "", float _f = 0.0)
  : i(_i), s(_s), f(_f){}
};
