// File: MapFuncT.h

#ifndef _MAPFUNCT_H_
#define _MAPFUNCT_H_

#include <iostream.h>
#include <String.h>
#include <MapAssoT.h>
#include <MapIterT.h>

template<class K, class V>
ostream& print_all(ostream& ros,
                   MapIterator<K,V> first,
                   MapIterator<K,V> last)
{
  while(first != last)
  {
    ros << *first << endl;
    first++;
  }
  return ros;
}

template<class K, class V>
ostream& print_sorted(ostream& ros,
                      MapIterator<K,V> first,
                      MapIterator<K,V> last)
{
  int ActVal = 0;
  bool NextVal = true;
  MapIterator<K,V> Next;

  while(NextVal)
  {
    Next = first;
    NextVal = false;

    while(Next != last)
    {
      if((*Next).Value == ActVal)
        ros << *Next << endl;
      else
        if((*Next).Value > ActVal)
          NextVal = true;

      Next++;
    }

    ActVal++;
  }
  return ros;
}

#endif
