// File: NaivGeoO.cc

#include <NaivGeoO.h>

int operator==(const GeoObj& left, const GeoObj& right)
{
  if(&left == &right)
    return 1;
  else
    return left.CompareTo(&right);
}

int operator!=(const GeoObj& left, const GeoObj& right)
{
  return !(left.CompareTo(&right));
}

ostream& operator<<(ostream& ros, const GeoObj& gos)
{
  ros << gos.GetTypeString();
  gos.WriteOn(ros);
  return ros;
}

istream& operator>>(istream& ris, GeoObj& gis)
{
  if(ris)
  {
    String TypeString;
    ris >> TypeString;

    if(TypeString == gis.GetTypeString())
      gis.ReadFrom(ris);
    else
    {
      cerr << "Error in GeoObj operator>>:"<< endl
           << "  read a " << TypeString << endl
           << "  but need a " << gis.GetTypeString() << endl;
      ris.setstate(ios::failbit);
    }
  }
  return ris;
}
