// sieve.cc

#include <vector>

int main()
{
  const int sievesize = 100;
  vector<int> sieve(sievesize, 1);

  for(int i = 2; i * i < sievesize; i++)
    if(sieve[i])
      for(int j = i + i; j < sievesize; j += i)
        sieve[j] = 0;

  for(int j = 2; j < sievesize; j++)
    if(sieve[j])
      cout << j << " ";
  cout << endl;

  return 0;
}

// 2 3 5 7 11 13 17 19 23 29 31 37 41 43 47 53 59 61 67 71 73 79 83 89 97 
